package com.test.log;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;

/**
 * Servlet Filter implementation class LogFilter
 */
@WebFilter(filterName = "LogFilter", urlPatterns = { "/*" })
public class LogFilter implements Filter {

	/**
	 * The filter configuration object we are associated with. If this value is
	 * null, this filter instance is not currently configured.
	 */
	private FilterConfig filterConfig = null;

	public LogFilter() {
	}

	/**
	 * @see Filter#destroy()
	 */
	public void destroy() {
	}

	/**
	 * @see Filter#init(FilterConfig)
	 */
	public void init(FilterConfig fConfig) throws ServletException {
		this.filterConfig = fConfig;
	}

	/**
	 * @see Filter#doFilter(ServletRequest, ServletResponse, FilterChain)
	 */
	public void doFilter(ServletRequest servletrequest,
			ServletResponse servletresponse, FilterChain chain)
			throws IOException, ServletException {
	   System.out.println("doFilterMethod called...");
		HttpServletRequest request = (HttpServletRequest) servletrequest;
		if (request.getRequestURI().toLowerCase().contains("/pages")) {
			TimeLogger.beginLog(getClass(), "LogFilter: " + request.getRequestURI());
		}

		chain.doFilter(servletrequest, servletresponse);

		if (request.getRequestURI().toLowerCase().contains("/pages")) {
			TimeLogger.endLog();
		}
	}

	/**
	 * Return a String representation of this object.
	 */
	@Override
	public String toString() {
		if (filterConfig == null)
			return "LogFilter()";
		StringBuffer sb = new StringBuffer("LogFilter(");
		sb.append(filterConfig);
		sb.append(")");
		return sb.toString();
	}

	/**
	 * Return the filter configuration object for this filter.
	 */
	public FilterConfig getFilterConfig() {
		return this.filterConfig;
	}

	/**
	 * Set the filter configuration object for this filter.
	 * 
	 * @param filterConfig
	 *            The filter configuration object
	 */
	public void setFilterConfig(FilterConfig filterConfig) {
		this.filterConfig = filterConfig;
	}

}
